### 创建用户
- 请求方法 `POST`

- 请求url：~/p/createUser

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| username | 用户名 | 是 |
| password | 密码 | 是 |
| nickname | 昵称 | 否 |
| icon | 头像 | 否 |
| tel | 电话 | 否 |
| email | 邮箱 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": {
        "username": "11",
        "nickname": "11",
        "icon": null,
        "tel": null,
        "email": null,
        "id": 9
    }
}
```

---

### 修改用户信息
- 请求方法 `POST` 需要登录

- 请求url：~/p/modifyUser

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| username | 用户名 | 否 |
| nickname | 昵称 | 否 |
| icon | 头像 | 否 |
| tel | 电话 | 否 |
| email | 邮箱 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": "success"
}
```

---

### 删除用户
- 请求方法 `GET` 需要登录

- 请求url：~/p/deleteUser

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| id | 被删除用户的id | 是 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": "success"
}
```

---

### 创建群组

- 请求方法 `POST` 需要登录

- 请求url：~/p/createGroup

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| name | 群组名 | 是 |
| description | 群描述 | 否 |
| icon | 群头像 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |
| data.id | 被创建群组的id |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": {
        "name": "aaaa",
        "description": "hal",
        "icon": null,
        "id": 6
    }
}
```

---

### 修改群组信息

- 请求方法 `POST` 需要登录

- 请求url：~/p/modifyGroup

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| name | 群组名 | 否 |
| description | 群描述 | 否 |
| icon | 群头像 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |
| data.id | 被创建群组的id |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": "success"
}
```

---

### 删除群组

- 请求方法 `GET` 需要登录

- 请求url：~/p/deleteGroup

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| id | 群组的id | 是 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": "success"
}
```

---

### 配置某个用户到群组

- 请求方法 `GET` 需要登录

- 请求url：~/p/groupAddUser

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| uid | 用户id | 是 |
| gid | 群组id | 是 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |
| data.id | 用户-群组的关系id |

- 实例

```json
{
    "code":0,
    "message":"success",
    "data":{
        "group_id":1,
        "user_id":1,
        "id":19
    }
}
```

---

### 将某用户移除群组

- 请求方法 `GET` 需要登录

- 请求url：~/p/groupRemoveUser

- 请求参数

|字段名|描述|必选|
|:-:|:-:|
| id | 用户-群组的关系id | 是 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code":0,
    "codeMessage":"success",
    "message":null
}
```

---

### 配置群组下有的用户
暂无

### 创建用户角色

- 请求方法 `POST` 需要登录

- 请求url：~/p/createRole

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| name | 角色名 | 是 |
| description | 角色的描述 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |
| data.id | 角色的id |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": {
        "name": "student",
        "description": "I'm a role of student",
        "id": 12
    }
}
```

--- 

### 更新用户角色

- 请求方法 `POST` 需要登录

- 请求url：~/p/modifyRole

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| id | 用户角色的id | 是 |
| name | 角色名 | 否 |
| description | 角色的描述 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": "success"
}
```

--- 

### 删除用户角色

- 请求方法 `GET` 需要登录

- 请求url：~/p/deleteRole

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| id | 用户角色的id | 是 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": "success"
}
```

--- 

### 列出用户角色

- 请求方法 `GET` 需要登录

- 请求url：~/p/listRole

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| page | 页码 | 否 |
| pageCount | 每页的条数 | 否 |
| keyword | 关键字 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "current_page":1,
    "data":[
        {
            "name":"hal",
            "description":"haloteacher"
        }
    ],
    "first_page_url":"http://local.pc:8888/repair_lite/p/listRole?page=1",
    "from":1,
    "last_page":7,
    "last_page_url":"http://local.pc:8888/repair_lite/p/listRole?page=7",
    "next_page_url":"http://local.pc:8888/repair_lite/p/listRole?page=2",
    "path":"http://local.pc:8888/repair_lite/p/listRole",
    "per_page":1,
    "prev_page_url":null,
    "to":1,
    "total":7
}
```

--- 

### 配置某个用户为某角色，该方法未更新
- 请求方法 `GET` 需要登录

- 请求url：~/p/assignUserRole

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| uid | 配置角色的用户id | 是 |
| barIds | 配置的菜单id，多个用逗号隔开 | 是 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |
| data.id | 菜单的id |

- 实例

```json
{
    "code": 0,
    "message": "success",
    "data": "success"
}
```

--- 

### 配置某个角色下的用户
暂无

### 创建菜单
- 请求方法 `POST` 需要登录

- 请求url：~/p/addActionBar

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| parent | 父级菜单id,0位顶级菜单id | 是 |
| name | 菜单的名字 | 是 |
| description | 菜单的描述 | 否 |
| icon | 菜单的图标 | 否 |
| link_type | 跳转的类型，当前只有url | 否 |
| link | 跳转的地址 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |
| data.id | 菜单的id |

- 实例

```json
{
    "code":0,
    "message":"success",
    "data":{
        "id":4,
        "parent":0,
        "name":"abdfdf",
        "description":null,
        "icon":null,
        "link_type":null,
        "link":null,
        "status":"normal",
        "created_at":"2019-03-13 09:23:32",
        "updated_at":"2019-03-13 09:23:32"
    }
}
```

--- 

### 更新菜单
- 请求方法 `POST` 需要登录

- 请求url：~/p/modifyActionBar

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| id | 菜单的id | 是 |
| parent | 父级菜单id,0位顶级菜单id | 否 |
| name | 菜单的名字 | 否 |
| description | 菜单的描述 | 否 |
| icon | 菜单的图标 | 否 |
| link_type | 跳转的类型，当前只有url | 否 |
| link | 跳转的地址 | 否 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "codeMessage": "success",
    "message": null
}
```

--- 

### 删除菜单
- 请求方法 `GET` 需要登录

- 请求url：~/p/deleteActionBar

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|
| id | 菜单的id | 是 |

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "code": 0,
    "codeMessage": "success",
    "message": null
}
```

--- 

### 列出菜单，根据当前用户列出有权限的菜单
- 请求方法 `GET` 需要登录

- 请求url：~/p/loadActionBar

- 请求参数

|字段名|描述|必选|
|:-:|:-:|:-:|

- 返回结果

|字段名|描述|
|:-:|:-:|
| code | 错误码，0： success， 非0：异常 |
| message | 错误码不为0时，该字段为错误码的描述 |

- 实例

```json
{
    "current_page":1,
    "data":[
        {
            "id":1,
            "parent":0,
            "name":"adafcds",
            "description":"haloqperio",
            "icon":"hh",
            "link_type":"url",
            "link":"local.pc",
            "status":"normal",
            "created_at":"2019-03-13 09:19:59",
            "updated_at":"2019-03-14 19:25:36"
        }
    ],
    "first_page_url":"http://local.pc:8888/repair_lite/p/loadActionBar?page=1",
    "from":1,
    "last_page":7,
    "last_page_url":"http://local.pc:8888/repair_lite/p/loadActionBar?page=7",
    "next_page_url":"http://local.pc:8888/repair_lite/p/loadActionBar?page=2",
    "path":"http://local.pc:8888/repair_lite/p/loadActionBar",
    "per_page":1,
    "prev_page_url":null,
    "to":1,
    "total":7
}
```

--- 